3 # B A C K U P N I N J A /()/
6 # Copyright (C) 2004 riseup.net -- property is theft.
8 # This program is free software; you can redistribute it and/or modify
9 # it under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 2 of the License, or
11 # (at your option) any later version.
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16 # GNU General Public License for more details.
19 #####################################################
22 function setupcolors() {
30 COLORS=($BLUE $GREEN $YELLOW $RED $PURPLE)
34 if [ "$usecolors" == "yes" ]; then
35 local typestr=`echo "$@" | sed 's/\(^[^:]*\).*$/\1/'`
36 [ "$typestr" == "Debug" ] && type=0
37 [ "$typestr" == "Info" ] && type=1
38 [ "$typestr" == "Warning" ] && type=2
39 [ "$typestr" == "Error" ] && type=3
40 [ "$typestr" == "Fatal" ] && type=4
41 color=${COLORS[$type]}
43 echo -e "$color$@$endcolor"
49 # We have the following message levels:
51 # 1 - normal messages - green
52 # 2 - warnings - yellow
55 # First variable passed is the error level, all others are printed
57 # if 1, echo out all warnings, errors, or fatal
58 # used to capture output from handlers
64 [ ${#@} -gt 1 ] || return
68 if [ $type == 100 ]; then
69 typestr=`echo "$@" | sed 's/\(^[^:]*\).*$/\1/'`
70 [ "$typestr" == "Debug" ] && type=0
71 [ "$typestr" == "Info" ] && type=1
72 [ "$typestr" == "Warning" ] && type=2
73 [ "$typestr" == "Error" ] && type=3
74 [ "$typestr" == "Fatal" ] && type=4
77 types=(Debug Info Warning Error Fatal)
78 typestr="${types[$type]}: "
83 if [ $echo_debug_msg == 1 ]; then
84 echo -e "$typestr$@" >&2
86 colorize "$typestr$@" >&2
89 if [ $print -lt $loglevel ]; then
90 if [ -w "$logfile" ]; then
91 colorize "$typestr$@" >> $logfile
118 messages[$msgcount]=$1
126 function setsection() {
131 # sets a global var with name equal to $1
132 # to the value of the configuration parameter $1
138 ret=`awk -f $scriptdir/parseini S=$CURRENT_SECTION P=$CURRENT_PARAM $CURRENT_CONF_FILE`
139 # if nothing is returned, set the default
140 if [ "$ret" == "" -a "$2" != "" ]; then
144 # replace * with %, so that it is not globbed.
145 ret="${ret//\\*/__star__}"
147 # this is weird, but single quotes are needed to
148 # allow for returned values with spaces. $ret is still expanded
149 # because it is in an 'eval' statement.
154 # enforces very strict permissions on configuration file $file.
157 function check_perms() {
159 local perms=`ls -ld $file`
161 if [ "$perms" != "------" ]; then
162 fatal "Configuration files must not be group or world readable! Dying on file $file"
164 if [ `ls -ld $file | awk '{print $3}'` != "root" ]; then
165 fatal "Configuration files must be owned by root! Dying on file $file"
169 # simple lowercase function
171 echo "$1" | tr [:upper:] [:lower:]
174 # simple to integer function
176 echo "$1" | tr [:alpha:] -d
180 # function isnow(): returns 1 if the time/day passed as $1 matches
181 # the current time/day.
183 # format is <day> at <time>:
189 # we grab the current time once, since processing
190 # all the configs might take more than an hour.
193 nowdayofweek=`date +%A`
194 nowdayofweek=`tolower "$nowdayofweek"`
199 whendayofweek=$1; at=$2; whentime=$3;
200 whenday=`toint "$whendayofweek"`
201 whendayofweek=`tolower "$whendayofweek"`
202 whentime=`echo "$whentime" | sed 's/:[0-9][0-9]$//'`
204 if [ "$whendayofweek" == "everyday" ]; then
205 whendayofweek=$nowdayofweek
208 if [ "$whenday" == "" ]; then
209 if [ "$whendayofweek" != "$nowdayofweek" ]; then
210 whendayofweek=${whendayofweek%s}
211 if [ "$whendayofweek" != "$nowdayofweek" ]; then
215 elif [ "$whenday" != "$nowday" ]; then
219 [ "$at" == "at" ] || return 0
220 [ "$whentime" == "$nowtime" ] || return 0
228 This script allows you to coordinate system backup by dropping a few
229 simple configuration files into /etc/backup.d/. Typically, this
230 script is run hourly from cron.
232 The following options are available:
233 -h, --help This usage message
234 -d, --debug Run in debug mode, where all log messages are
235 output to the current shell.
236 -f, --conffile FILE Use FILE for the main configuration instead
237 of /etc/backupninja.conf
238 -t, --test Run in test mode, no actions are actually taken.
239 -n, --now Perform actions now, instead of when they
241 --run FILE Execute the specified action file and then exit.
242 When using colored output, there are:
245 debug "Debugging info (when run with -d)"
246 info "Informational messages (verbosity level 4)"
247 warning "Warnings (verbosity level 3 and up)"
248 error "Errors (verbosity level 2 and up)"
249 fatal "Fatal, halting errors (always shown)"
253 ## this function handles the running of a backup action
255 ## these globals are modified:
256 ## fatals, errors, warnings, actions_run, errormsg
259 function process_action() {
265 # skip over this config if "when" option
266 # is not set to the current time.
267 getconf when "$defaultwhen"
268 if [ "$processnow" == 1 ]; then
269 info "running $file because of --now"
277 if [ $ret == 0 ]; then
278 debug "skipping $file because it is not $w"
281 info "running $file because it is $w"
287 let "actions_run += 1"
290 local bufferfile="/tmp/backupninja.buffer.$$"
291 echo "" > $bufferfile
294 . $scriptdir/$suffix $file
297 echo $a >> $bufferfile
298 [ $debug ] && colorize "$a"
302 # ^^^^^^^^ we have a problem! we can't grab the return code "$?". grrr.
305 _warnings=`cat $bufferfile | grep "^Warning: " | wc -l`
306 _errors=`cat $bufferfile | grep "^Error: " | wc -l`
307 _fatals=`cat $bufferfile | grep "^Fatal: " | wc -l`
309 ret=`grep "\(^Warning: \|^Error: \|^Fatal: \)" $bufferfile`
311 if [ $_fatals != 0 ]; then
312 msg "*failed* -- $file"
313 errormsg="$errormsg\n== failures from $file ==\n\n$ret\n"
314 elif [ $_errors != 0 ]; then
315 msg "*error* -- $file"
316 errormsg="$errormsg\n== errors from $file ==\n\n$ret\n"
317 elif [ $_warnings != 0 ]; then
318 msg "*warning* -- $file"
319 errormsg="$errormsg\n== warnings from $file ==\n\n$ret\n"
321 msg "success -- $file"
322 # elif [ $retcode == 0 ]; then
323 # msg "success -- $file"
325 # msg "unknown -- $file"
328 let "fatals += _fatals"
329 let "errors += _errors"
330 let "warnings += _warnings"
333 #####################################################
337 conffile="/etc/backupninja.conf"
340 ## process command line options
342 while [ $# -ge 1 ]; do
345 -d|--debug) debug=1;;
346 -t|--test) test=1;debug=1;;
347 -n|--now) processnow=1;;
352 fatal "-f|--conffile option must be followed by an existing filename"
355 # we shift here to avoid processing the file path
364 fatal "--run option must be fallowed by a backupninja action file"
371 fatal "Unknown option $1"
383 ## Load and confirm basic configuration values
386 [ -r "$conffile" ] || fatal "Configuration file $conffile not found."
387 scriptdir=`grep scriptdirectory $conffile | awk '{print $3}'`
388 [ -n "$scriptdir" ] || fatal "Cound not find entry 'scriptdirectory' in $conffile"
389 [ -d "$scriptdir" ] || fatal "Script directory $scriptdir not found."
392 # get global config options (second param is the default)
393 getconf configdirectory /etc/backup.d
395 getconf reportsuccess yes
396 getconf reportwarning yes
398 getconf when "Everyday at 01:00"
400 getconf logfile /var/log/backupninja.log
401 getconf usecolors "yes"
402 getconf SLAPCAT /usr/sbin/slapcat
403 getconf RDIFFBACKUP /usr/bin/rdiff-backup
404 getconf MYSQL /usr/bin/mysql
405 getconf MYSQLHOTCOPY /usr/bin/mysqlhotcopy
406 getconf MYSQLDUMP /usr/bin/mysqldump
407 getconf GZIP /bin/gzip
408 getconf RSYNC /usr/bin/rsync
410 [ -d "$configdirectory" ] || fatal "Configuration directory '$configdirectory' not found."
412 if [ "$UID" != "0" ]; then
413 echo "$0 can only be run as root"
417 ## Process each configuration file
419 # by default, don't make files which are world or group readable.
422 # these globals are set by process_action()
429 if [ "$singlerun" ]; then
432 files=`find $configdirectory -mindepth 1 | sort -n`
435 for file in $files; do
436 [ -f "$file" ] || continue
440 base=`basename $file`
441 if [ "${base:0:1}" == "0" ]; then
442 info "Skipping $file"
446 if [ -e "$scriptdir/$suffix" ]; then
447 process_action $file $suffix
449 error "Can't process file '$file': no handler script for suffix '$suffix'"
450 msg "*missing handler* -- $file"
454 ## mail the messages to the report address
456 if [ $actions_run == 0 ]; then doit=0
457 elif [ "$reportemail" == "" ]; then doit=0
458 elif [ $fatals != 0 ]; then doit=1
459 elif [ $errors != 0 ]; then doit=1
460 elif [ "$reportsuccess" == "yes" ]; then doit=1
461 elif [ "$reportwarning" == "yes" -a $warnings != 0 ]; then doit=1
465 if [ $doit == 1 ]; then
466 debug "send report to $reportemail"
468 [ $warnings == 0 ] || subject="WARNING"
469 [ $errors == 0 ] || subject="ERROR"
470 [ $fatals == 0 ] || subject="FAILED"
473 for ((i=0; i < ${#messages[@]} ; i++)); do
477 } | mail $reportemail -s "backupninja: $hostname $subject"